/*
 * Access a block region.
 *
 * Copyright (C) 2018, 2019, 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <stdio.h>

#include <fsserver/accessor.h>



/* Block region. */

class Block_region_accessor : public PagingAccessor
{
private:
  /* Block region data. */

  char *_data;

public:
  /* Initialisation and administration. */

  explicit Block_region_accessor(Paging *paging, char *data, size_t size)
  : PagingAccessor(paging, size), _data(data)
  {
  }

  /* Accessor methods. */

  /* NOTE: Should provide a unique identifier, perhaps associated with the block
     NOTE: device. */

  unsigned long get_fileid() { return 0; }

  long flush() { return 0; }

  size_t fstat(char *buffer, size_t length);

  size_t read(size_t start, char *buffer, size_t length);

  size_t write(size_t start, char *buffer, size_t length);
};
